/*
 * Copyright (c) Sun Microsystems, Inc. 1996-1997. All rights reserved.
 *
 * License is granted to copy, to use, and to make and to use derivative works
 * for research and evaluation purposes, provided that Sun Microsystems is
 * acknowledged in all documentation pertaining to any such copy or
 * derivative work. Sun Microsystems grants no other licenses expressed or
 * implied. The Sun Microsystems  trade name should not be used in any
 * advertising without its written permission.
 *
 * SUN MICROSYSTEMS MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS
 * SOFTWARE FOR ANY PARTICULAR PURPOSE.  The software is provided "as is"
 * without express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this software.
 */

#ifndef _NETINET_PKTSCHED_H
#define	_NETINET_PKTSCHED_H

#pragma ident "@(#)pktsched.h  1.2     97/02/17 SMI"

#include <sys/ioctl.h>
#include <sys/ioccom.h>
#include <sys/dlpi.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _KERNEL

#ifndef DL_IOC_PKTSCHED_INIT
#define DL_IOC_PKTSCHED_INIT            (DLIOC|11)
#define DL_IOC_PKTSCHED_TEARDOWN        (DLIOC|12)
#endif

typedef struct _pkt_sched_cb_ {
	void (*pktsched_cb)(void *, int);
	void *pktsched_cb_arg;
} pkt_sched_cb_t;

extern int pktsched_init(queue_t *q, pkt_sched_cb_t *cb, int *flag,
	kmutex_t *mtx, kcondvar_t *cv);
extern int pktsched_teardown(queue_t *q, int *flag, kmutex_t *mtx,
	kcondvar_t *cv);

#endif

#ifdef __cplusplus
}
#endif
#endif /* !_NETINET_CBQ_H */
